#!/usr/bin/webif-page -p /bin/sh
###
 #
 # FreeWLAN Addons - http://www.freewlan.info
 #
 # This Script is based on work from http://www.fonfan.de
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
 # as published by the Free Software Foundation; either version 2
 # of the License, or (at your option) any later version.
 #
 # This program is distributed in the hope that it will be useful,
 # but WITHOUT ANY WARRANTY; without even the implied warranty of
 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 # GNU General Public License for more details.
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 # MA  02110-1301, USA
 #
 # http://www.gnu.org/copyleft/gpl.html
 #
###

. /usr/lib/webif/webif.sh

validate <<EOF
string|FORM_submit|@TR<<Submit>>|max=10|$FORM_submit
EOF

if [ "$?" != "0" ]; then
	FORM_submit=""
fi

sel_backuprestore=1

. /usr/lib/webif/advanced.sh

header "BackupRestore_Title#Fonera settings backup and restore"

# file will be removed if another WebIf page is loaded (watch out webif.sh)
if [ -f /etc/ethers ]; then
	taroptions="/etc/ethers"
else
	taroptions=""
fi
if [ -f /etc/debug ]; then
	taroptions="$taroptions /etc/debug"
fi
if [ -f /www/cgi-bin/webif/myoptions.sh ]; then
	taroptions="$taroptions /www/cgi-bin/webif/myoptions.sh "
fi

settingsfile="$(date | awk -F" " '{print $6$2$3}')_settings.fon.image"
tar -czf /www/"$settingsfile" /etc/config /etc/passwd /etc/addon_version /etc/fon_version /etc/fon_revision /etc/hostname $taroptions > /dev/null 2> /dev/null

display_form <<EOF
	infotable|backuprestore_info#Here you can backup and restore the settings of the router.
EOF

do_upgrade() {
	cat >> /tmp/restore.tar.gz
	mkdir /tmp/restore
	tar -xzf /tmp/restore.tar.gz -C /tmp/restore
	fonera_version=`cat /etc/addon_version`
	settings_version=`cat /tmp/restore/etc/addon_version`
	if [ $fonera_version != $settings_version ]; then
		echo "</pre>"
		echo "<br /><br /><font color=grey><b>@TR<<file_version_unequal|The settings you are about to restore were not saved under the current firmware version.>></b></font>"
		echo "<br /><br /><font color=grey><b>@TR<<file_version_show|Actual firmware version: \""$fonera_version"\", version of settings file: \""$settings_version"\".>></b></font>"
		echo "<br /><br /><font color=red><b>@TR<<operation aborted>></b></font>"
		rm -r /tmp/restore
		rm /tmp/restore.tar.gz
		footer
		exit
	else
		cp /tmp/restore/etc/passwd /etc/passwd- && mv /tmp/restore/etc/passwd /etc/passwd
		mv /tmp/restore/etc/config/* /etc/config
		mv /tmp/restore/etc/fon_version /fon_version
		mv /tmp/restore/etc/fon_revision /etc/fon_revision
		mv /tmp/restore/etc/hostname /etc/hostname
		[ -f /tmp/restore/etc/ethers ] && mv /tmp/restore/etc/ethers /etc/ethers
		[ -f /tmp/restore/etc/debug ] && mv /tmp/restore/etc/debug /etc/debug
		[ -f /tmp/restore/www/cgi-bin/webif/myoptions.sh ] && mv /tmp/restore/www/cgi-bin/webif/myoptions.sh /www/cgi-bin/webif/myoptions.sh
		rm -r /tmp/restore
		
		load_settings fon
		get_default mode wan mode
		get_default enc wan enc
		[ "$FORM_mode" == "wlan" ] && [ "$FORM_enc" == "WPA" ] && {
			get_default rssid wan rssid
			get_default key wan key
			echo 'ap_scan=1' > /etc/wpa_supplicant.conf
			echo 'network={' >> /etc/wpa_supplicant.conf
			echo 'ssid="'$FORM_rssid'"' >> /etc/wpa_supplicant.conf
			echo 'scan_ssid=1' >> /etc/wpa_supplicant.conf
			echo 'psk="'$FORM_key'"' >> /etc/wpa_supplicant.conf
			echo 'priority=2' >> /etc/wpa_supplicant.conf
			echo '}' >> /etc/wpa_supplicant.conf
		}
		
		echo "</pre>"
		echo "<br /><br /><font color=grey><b>@TR<<Restore_success|The restore process was successful.>></b></font>"
		echo "<br /><br /><font color=red><b>REBOOTING</b></font>"
		rm /tmp/restore.tar.gz
		footer
		sleep 2
display_form <<EOF
	autoloadpage|status|reboot
EOF
	#	reboot
	# for the purpose of testing only:
		exit
	fi
}

read_var() {
	NAME=""
	FILENAME=""
	while :; do
		read LINE
		LINE="${LINE%%[^0-9A-Za-z]}"
		equal "$LINE" "$BOUNDARY" && read LINE
		empty "$NAME$LINE" && exit
		case "${LINE%%:*}" in
			Content-Disposition)
				NAME="${LINE##*; name=\"}"
				NAME="${NAME%%\"*}"
				FILENAME="${LINE##*; filename=\"}"
				FILENAME="${FILENAME%%\"*}"
				;;
		esac
		empty "$LINE" && return
	done
}

cat <<EOF
<script type="text/javascript">
	function statusupdate() {
		document.getElementById("form_submit").style.display = "none";
		document.getElementById("status_text").style.display = "none";
		return true;
	}
	function printStatus() {
		document.write('<div style="display: none; font-size: 14pt; font-weight: bold;" id="status_text" />@TR<<Restoring...>>&nbsp;</div>');
	}
	function backup() {
		location.href='/$settingsfile'
	}
</script>
EOF
display_form <<EOF
	start_table|0|10|5
	add_row
		add_label_cell|&nbsp;
	end_row
	add_row
		add_label_cell|@TR<<Package_download#Click following button to download Fonera settings file>>.
	end_row
	add_row
		add_download_button|@TR<<Backup Settings>>|backup
	end_row
	end_table
	add_form|restore|$SCRIPT_NAME$PATH_INFO|statusupdate
		start_table|0|10|5
			add_row
				add_label_cell|@TR<<Packageback_selection#Select a Fonera settings file>>.
			end_row
			add_row
				add_fileinput_cell|settings
			end_row
			add_row
				call_js|printStatus
				add_input_submit_button|submit|@TR<<Restore Settings>>|statusupdate
			end_row
		end_table
	end_form
EOF

equal "$REQUEST_METHOD" "POST" && {
	equal "${CONTENT_TYPE%%;*}" "multipart/form-data" || ERR=1
	BOUNDARY="${CONTENT_TYPE##*boundary=}"
	empty "$BOUNDARY" && ERR=1

	empty "$ERR" || {
		echo "@TR<<Wrong format|Wrong data format>>"
		footer
		exit
	}
display_form <<EOF
	start_div
EOF
	while :; do
		read_var
		case "$FILENAME" in
			*settings.fon.image)
				do_upgrade
				;;
		esac
		empty "$NAME" || {
		echo "@TR<<Wrong format|Wrong data format>>"
		footer
		exit
		}
	done

display_form <<EOF
	end_div
EOF

}

footer
